<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on October 28, 2010 at 10:46:18 am</time-stamp>
<!-- Changes from: NGUBA-Application(Green.62,carry)  to: NGUBA-Application(Green.63,carry) -->


<methods>
<class-id>PROVISO.UBA.InputSchemaMultiJoinProcessor</class-id> <category>public</category>

<body package="NGUBA-Application" selector="processInputDescriptor:">processInputDescriptor: anInputDescriptor
	| stream |
	(self shouldIgnore: anInputDescriptor)
		ifTrue: [^self].
	((self hasValidTimestampForDescriptor: anInputDescriptor) or: [self schema filePeriod isNil])
		ifFalse: [self logNoTimestampForDescriptor: anInputDescriptor].
	stream := self newStreamFor: anInputDescriptor.
	descriptorStreams at: anInputDescriptor put: stream.
	mergeStream addStream: stream.</body>
</methods>


<methods>
<class-id>PROVISO.UBA.StreamSort</class-id> <category>private</category>

<body package="NGUBA-Application" selector="recoverAtOrBefore:">recoverAtOrBefore: aNumber

	super recoverAtOrBefore: aNumber.
	self initializeForNextPeriod.</body>

<body package="NGUBA-Application" selector="flush">flush
	
	| sorted lastTimestamp time |
	self system 
		logDebugThree: #STREAM_SORT
		template: '&lt;1s&gt;: End of Period for &lt;2s&gt;. Sending heartbeat for &lt;3s&gt;'
		arguments: {self name. self periodPolicy printPeriodString. (self startOfPeriod - 1) pvOpportunisticPrintString}.
	
	self emitEndOfPeriodFor: (self startOfPeriod - 1).
	self system 
		logInfo: #STREAM_SORT
		template: '&lt;1s&gt;: Close Period for &lt;2s&gt;. Sorting &lt;3p&gt; buffered tuples'
		arguments: {self name. self periodPolicy printPeriodString. self buffer size}.
	lastTimestamp := nil.
	time := Time millisecondsToRun:
		[sorted := SortedCollection new: self buffer size.
		sorted
			sortBlock: [:x :y | x timestamp &lt; y timestamp];
			addAll: self buffer].
	self system 
		logInfo: #PERF_STREAM_SORT
		template: '&lt;1s&gt;: Sorted &lt;3p&gt; buffered tuples for period &lt;2s&gt; in &lt;4s&gt; seconds. Now flushing tuples'
		arguments: {self name. self periodPolicy printPeriodString. self buffer size. (time / 1000.0d) asDouble asPvPrintString }.
	sorted
		do: 
			[:eachTuple | 
			eachTuple timestamp ifNotNil: 
				[:eachTs | 
				(lastTimestamp isNil or: [eachTs &gt; lastTimestamp]) 
					ifTrue: 
						[lastTimestamp := eachTs]].
				self produceAndHandle: eachTuple].</body>

<body package="NGUBA-Application" selector="produceAndHandle:">produceAndHandle: aTuple

	self handleNormalTuple: aTuple.
	self produce: aTuple.</body>
</methods>

<methods>
<class-id>PROVISO.UBA.StreamSort</class-id> <category>period policy callbacks</category>

<body package="NGUBA-Application" selector="commit">commit 
	
	self flush.
	^super commit</body>
</methods>


<methods>
<class-id>PROVISO.UBA.UBAOperator</class-id> <category>period policy callbacks</category>

<body package="NGUBA-Application" selector="onEndOfPeriod:">onEndOfPeriod: aTimestamp 
	
	super onEndOfPeriod: aTimestamp.
	self modelProprietor ifNotNil: 
		[:modelAccessor | 
		modelAccessor handleHeartbeat: 
			(PvStreamHeartbeat endOfPeriodTimestamp: aTimestamp)]</body>
</methods>



</st-source>
